> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.withpersona.com/2020-05-18/api-reference/client-token-versions/rotate-client-token/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.withpersona.com/_mcp/server. # Create a New Client Token Version POST https://api.withpersona.com/api/v1/client-tokens/{client-token-id}/rotate Content-Type: application/json Rotates a Client Token by creating a new version without disabling existing versions. A Client Token can have up to five usable versions; disable an existing version before rotating if the limit has been reached. The new version's value is returned in the `included` response data. Copy the value when you create the version, then update your integrations to use it. Reference: https://docs.withpersona.com/api-reference/client-token-versions/rotate-client-token ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `client-token-id` (string, required) — The ID of the client token to be rotated. ### Query parameters - `include` (string, optional) — A comma-separated list of relationship paths. This can be used to customize which related resources will be fully serialized in the `included` key in the response. See [Serialization](https://docs.withpersona.com/serialization#inclusion-of-related-resources) for more details. - `fields` (map from string to string, optional) — Comma-separated list(s) of attributes to include in the response. This can be used to customize which attributes will be serialized in the response. See [Serialization](https://docs.withpersona.com/serialization#sparse-fieldsets) for more details. ### Headers - `Key-Inflection` (enum, optional) — Determines casing for the API response. - Allowed values: `camel`, `kebab`, `snake` - `Idempotency-Key` (string, optional) — Ensures the request is idempotent. - `Persona-Version` (enum, optional) — Server API version. More info on versioning can be found [here](https://docs.withpersona.com/versioning). - Allowed values: `2025-12-08`, `2025-10-27`, `2023-01-05`, `2022-09-01`, `2021-08-18`, `2021-07-05`, `2021-02-21`, `2020-05-18` ### Body (application/json) This endpoint expects an object. - `meta` (ClientTokensClientTokenIdRotatePostRequestBodyContentApplicationJsonSchemaMeta, optional) ## Response ### 200 This endpoint returns a Client Token. - `data` (client-token, required) — A Client Token resource - `included` (list of client-token-version, optional) ## Errors ### 400 Bad Request Error The request was unacceptable, often due to invalid parameters. - `errors` (list of ClientTokensClientTokenIdRotatePostResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 401 Unauthorized Error An invalid API key was provided. - `errors` (list of ClientTokensClientTokenIdRotatePostResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 403 Forbidden Error The given API key doesn’t have permissions to perform the request or a quota has been exceeded. - `errors` (list of ClientTokensClientTokenIdRotatePostResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 404 Not Found Error The requested resource doesn’t exist. - `errors` (list of ClientTokensClientTokenIdRotatePostResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 409 Conflict Error The request conflicts with another request, often due to attempting to create a duplicate resource. - `errors` (list of ClientTokensClientTokenIdRotatePostResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 422 Unprocessable Entity Error The request modifies the resource in an unacceptable way, often due to an invalid action or parameter. - `errors` (list of ClientTokensClientTokenIdRotatePostResponsesContentApplicationJsonSchemaErrorsItems, optional) ### 429 Too Many Requests Error Your organization’s rate limit has been exceeded. We recommend an exponential backoff on requests. - `errors` (list of ClientTokensClientTokenIdRotatePostResponsesContentApplicationJsonSchemaErrorsItems, optional) ## Types ### ClientTokensClientTokenIdRotatePostRequestBodyContentApplicationJsonSchemaMeta - `expires-in-seconds` (integer, optional) — The number of seconds until the new version expires. If omitted, falls back to the Client Token's `version-expires-in-seconds`, if set; otherwise the new version does not expire. ### client-token A Client Token resource - `type` ("client-token", optional) - `id` (string, optional) - `attributes` (ClientTokenAttributes, optional) - `relationships` (ClientTokenRelationships, optional) ### client-token-version A Client Token Version resource - `type` ("client-token-version", optional) - `id` (string, optional) - `attributes` (ClientTokenVersionAttributes, optional) - `relationships` (ClientTokenVersionRelationships, optional) ### ClientTokensClientTokenIdRotatePostResponsesContentApplicationJsonSchemaErrorsItems - `title` (string, optional) - `details` (string, optional) ### ClientTokenAttributes - `name` (string, optional) — The name of the client token - `api-version` (date, optional) — The API version used by this client token - `api-key-inflection` (string, optional) — The key inflection used by this client token - `permissions` (list of string, optional) — List of permissions granted to this client token - `domain-allowlist` (list of string, optional) — List of domains allowed to use this client token - `allowed-resources` (list of string, optional) — List of resources that this client token is authorized to manipulate - `version-expires-in-seconds` (integer, optional, nullable) — How long newly minted client token versions live before expiring, in seconds (max 10 years). Null means new versions do not expire by default. - `disabled-at` (datetime, optional, nullable) — When this client token was disabled - `disabled` (boolean, optional) — Whether this client token is disabled - `created-at` (datetime, optional) — When this client token was created ### ClientTokenRelationships - `versions` (ClientTokenRelationshipsVersions, optional) ### ClientTokenVersionAttributes - `value` (string, optional) — The Client Token Version value, returned for a retrieved or newly created version. This should be treated with the utmost security. - `created-at` (datetime, optional) — When this client token version was created - `expires-at` (datetime, optional, nullable) — When this client token version expires - `status` (string, optional) — The lifecycle status of this client token version: `active` or `disabled`. ### ClientTokenVersionRelationships - `client-token` (ClientTokenVersionRelationshipsClientToken, optional) ### ClientTokenRelationshipsVersions - `data` (list of ClientTokenRelationshipsVersionsDataItems, optional) ### ClientTokenVersionRelationshipsClientToken - `data` (ClientTokenVersionRelationshipsClientTokenData, optional) ### ClientTokenRelationshipsVersionsDataItems - `type` ("client-token-version", optional) - `id` (string, optional) ### ClientTokenVersionRelationshipsClientTokenData - `type` ("client-token", optional) - `id` (string, optional) ## Examples **Request** ```json {} ``` **Response** ```json { "data": { "type": "client-token", "id": "ctk_ABC123", "attributes": { "name": "Default Client Token", "api-version": "2023-01-05", "api-key-inflection": "kebab", "permissions": [ "sentinel.collect", "txn.write" ], "domain-allowlist": [ "*.example.com", "api.example.com" ], "allowed-resources": [ "txntp_ABC123", "txntp_DEF456" ], "version-expires-in-seconds": null, "disabled-at": null, "disabled": false, "created-at": "2023-08-17T23:18:13.000Z" }, "relationships": { "versions": { "data": [ { "type": "client-token-version", "id": "ctkv_DEF456" } ] } } }, "included": [ { "type": "client-token-version", "id": "ctkv_DEF456", "attributes": { "value": "persona_production_abcdefg", "created-at": "2023-08-18T23:18:13.000Z", "expires-at": null, "status": "active" }, "relationships": { "client-token": { "data": { "type": "client-token", "id": "ctk_ABC123" } } } } ] } ``` **SDK Code** ```python Success import requests url = "https://api.withpersona.com/api/v1/client-tokens/client-token-id/rotate" payload = {} headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript Success const url = 'https://api.withpersona.com/api/v1/client-tokens/client-token-id/rotate'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go Success package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.withpersona.com/api/v1/client-tokens/client-token-id/rotate" payload := strings.NewReader("{}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Success require 'uri' require 'net/http' url = URI("https://api.withpersona.com/api/v1/client-tokens/client-token-id/rotate") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{}" response = http.request(request) puts response.read_body ``` ```java Success import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.withpersona.com/api/v1/client-tokens/client-token-id/rotate") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{}") .asString(); ``` ```php Success request('POST', 'https://api.withpersona.com/api/v1/client-tokens/client-token-id/rotate', [ 'body' => '{}', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp Success using RestSharp; var client = new RestClient("https://api.withpersona.com/api/v1/client-tokens/client-token-id/rotate"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift Success import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.withpersona.com/api/v1/client-tokens/client-token-id/rotate")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```